module chatt (
	clk,
	clr_n,
	button,
	sw_out
	);
	
	input		clk;
	input		clr_n;
	input		button;
	output		sw_out;

	reg	[19:0]	time_cnt;
	reg	[ 3:0]	sht_reg;
	reg 		sw_reg;
	
	always @ (posedge clk or negedge clr_n) begin
		if (!clr_n) begin
			time_cnt <= 20'h0_0000;
		end
		else begin
			time_cnt <= time_cnt + 1'b1;
		end
	end
	
	always @ (posedge clk or negedge clr_n) begin
		if (!clr_n) begin
			sht_reg <= 4'b0000;
		end
		else begin
			if (sht_reg == 4'b1000) begin
				sht_reg <= 4'b0000;
			end
			else begin
				if (time_cnt == 20'hF_FFFF) begin
					sht_reg <= {sht_reg [2:0], button};
				end
			end
		end
	end
	
	always @ (posedge clk or negedge clr_n) begin
		if (!clr_n) begin
			sw_reg <= 1'b0;
		end
		else begin
			if (sht_reg == 4'b1000) begin
				sw_reg <= ~sw_reg;
			end
		end
	end

	assign sw_out = sw_reg;

endmodule
