module fpga_top (
	clock_50,
	clr,
	button,
	led
	);
	
	input			clock_50;
	input			clr;
	input			button;
	output	[ 7:0]	led;

	wire			sw_sel;
	wire	[31:0]	cnt_data;
	
	chatt inst1 (
		.clk	(clock_50),
		.clr_n	(clr),
		.button	(button),
		.sw_out	(sw_sel)
		);
	
	simple_counter inst2 (
		.clk	(clock_50),
		.clr_n	(clr),
		.cnt_out(cnt_data)
		);
	
	mux_zero inst3 (
		.clk	(clock_50),
		.clr_n	(clr),
		.sel	(sw_sel),
		.data_0	(cnt_data[29:22]),
		.data_1	(cnt_data[26:19]),
		.dout	(led)
		)
		
endmodule
