LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
	
ENTITY fpga_top IS 
	PORT
	(
		clock_50	:	IN  STD_LOGIC;
		clr			:	IN  STD_LOGIC;
		button		:	IN  STD_LOGIC;
		led			:	OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
	);
END fpga_top;

ARCHITECTURE rtl OF fpga_top IS

	SIGNAL	sw_sel	:	STD_LOGIC;
	SIGNAL	cnt_data	:	STD_LOGIC_VECTOR (31 DOWNTO 0);

	COMPONENT chatt
		PORT (
			clk		:	IN STD_LOGIC;
			clr_n		:	IN STD_LOGIC;
			button	:	IN STD_LOGIC;
			sw_out	:	OUT STD_LOGIC
		);
	END COMPONENT;

	COMPONENT simple_counter
		PORT (
			clk		:	IN STD_LOGIC;
			clr_n		:	IN STD_LOGIC;
			cnt_out	:	OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
		);
	END COMPONENT;

	COMPONENT mux_zero
		PORT (
			clk		:	IN STD_LOGIC;
			clr_n		:	IN STD_LOGIC;			
			sel		:	IN STD_LOGIC;
			data_0	:	IN STD_LOGIC_VECTOR (7 DOWNTO 0);
			data_1	:	IN STD_LOGIC_VECTOR (7 DOWNTO 0);
			dout		:	OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
		);
	END COMPONENT;

BEGIN

	inst1 : chatt
		PORT MAP ( 
			clk => clock_50,
			clr_n => clr,
			button => button,
			sw_out => sw_sel
			);
	
	inst2 : simple_counter
		PORT MAP (
			clk => clock_50,
			clr_n => clr,
			cnt_out => cnt_data
			);

	inst3 : mux_zero
		PORT MAP (
			clk => clock_50,
			clr_n => clr,
			sel => sw_sel,
			data_0 => cnt_data (29 DOWNTO 22),
			data_1 => cnt_data (26 DOWNTO 19),
			dout => led
			);

END rtl;