LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY simple_counter IS
	PORT (
		clk		:	IN STD_LOGIC;
		clr_n	:	IN STD_LOGIC;
		cnt_out	:	OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
	);
END simple_counter;

ARCHITECTURE rtl OF simple_counter IS

	SIGNAL	cnt_reg	:	STD_LOGIC_VECTOR (31 DOWNTO 0):=(OTHERS => '0');

BEGIN

	PROCESS (clk, clr_n) BEGIN
		IF (clr_n = '0') THEN
			cnt_reg <= (OTHERS => '0');
		ELSE
			IF (clk'EVENT AND clk = '1') THEN
				cnt_reg <= cnt_reg + '1';
			END IF;
		END IF;
	END PROCESS;

	cnt_out <= cnt_reg;

END rtl;

